<!--
Vue router does not support external links yet and will only append a url to its current root path.
You can/should replace the usage of this component when Vue Router supports external links by itself.
13.06.18
-->

<template>
  <component v-bind="linkProps(to, readPath, readQuery, readFragment)">
    <slot></slot>
  </component>
</template>

<script>
  export default {
    props: {
      to: {
        default: '',
        required: false,
      },
      path: {
        default: '',
        required: false,
      },
      query: {
        default: '',
        required: false,
      },
      fragment: {
        default: '',
        required: false,
      },
      target: {
        default: '_self',
        required: false,
      },
    },
    computed: {
      readPath: {
        get() {
          return (this.path && typeof this.path === 'string') ? this.path : '';
        },
      },
      readQuery: {
        get() {
          if (!this.query) return '';
          if (typeof this.query === 'object') return `?${Object.keys(this.query).map(key => `${key}=${this.query[key]}`).join('&')}`;
          if (typeof this.query === 'string') return /^\?([a-zA-Z]+[=].*)([&][a-zA-Z]+[=].*)*$/.test(this.query) ? this.query : '';
          return '';
        },
      },
      readFragment: {
        get() {
          return (this.fragment && typeof this.fragment === 'string') ? `${this.fragment}` : '';
        },
      },
    },
    methods: {
      linkProps(to, path, query, fragment) {
        if (!(typeof to === 'object') && (/^(http(s)?|ftp|mailto|tel):/.test(to) || /^\//.test(path) || /^\?/.test(query) || /^#/.test(fragment))) {
          return {
            is: 'a',
            href: `${to}${path}${query}${fragment}`,
            target: this.target,
            rel: 'noopener',
          };
        }
        return {
          is: 'router-link',
          to,
        };
      },
    },
  };
</script>
